import _extends from "@babel/runtime/helpers/esm/extends";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import React, { useContext, useMemo } from "react";
import hoistNonReactStatics from "hoist-non-react-statics";
import { getDisplayName } from "./utils";
import { StoreManager } from "./context";
import { useModel } from "./hooks";
export var connect = function connect(selectors, actions) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (Component) {
    var pure = typeof options.pure === "boolean" ? options.pure : true;
    var forwardRef = options.forwardRef;
    var WrappedComponent = typeof Component === "function" && pure ? React.memo(Component) : Component;

    var ConnectComponent = function ConnectComponent(props) {
      var context = useContext(StoreManager);
      var modelProps = useModel(selectors, actions, props);
      var newContext = useMemo(function () {
        return _objectSpread({}, context, {
          instanceId: modelProps.instanceId,
          renderLevel: context.renderLevel + 1
        });
      }, [context, modelProps.instanceId]);
      var dom =
      /*#__PURE__*/
      React.createElement(WrappedComponent, _extends({}, props, modelProps));
      return (
        /*#__PURE__*/
        React.createElement(StoreManager.Provider, {
          value: newContext
        }, dom)
      );
    };

    ConnectComponent.displayName = "MVCInyectProps(".concat(getDisplayName(Component), ")");
    var Connect = React.memo(ConnectComponent);

    if (forwardRef) {
      Connect = React.forwardRef(function (props, ref) {
        return (
          /*#__PURE__*/
          React.createElement(ConnectComponent, _extends({}, props, {
            reduxMVCForwardedRef: ref
          }))
        );
      });
    }

    Connect.displayName = "MVCConnect(".concat(getDisplayName(Component), ")");
    return hoistNonReactStatics(Connect, Component);
  };
};