"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connect = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _react = _interopRequireWildcard(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _utils = require("./utils");

var _context = require("./context");

var _hooks = require("./hooks");

var connect = function connect(selectors, actions) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (Component) {
    var pure = typeof options.pure === "boolean" ? options.pure : true;
    var forwardRef = options.forwardRef;
    var WrappedComponent = typeof Component === "function" && pure ? _react["default"].memo(Component) : Component;

    var ConnectComponent = function ConnectComponent(props) {
      var context = (0, _react.useContext)(_context.StoreManager);
      var modelProps = (0, _hooks.useModel)(selectors, actions, props);
      var newContext = (0, _react.useMemo)(function () {
        return (0, _objectSpread2["default"])({}, context, {
          instanceId: modelProps.instanceId,
          renderLevel: context.renderLevel + 1
        });
      }, [context, modelProps.instanceId]);

      var dom =
      /*#__PURE__*/
      _react["default"].createElement(WrappedComponent, (0, _extends2["default"])({}, props, modelProps));

      return (
        /*#__PURE__*/
        _react["default"].createElement(_context.StoreManager.Provider, {
          value: newContext
        }, dom)
      );
    };

    ConnectComponent.displayName = "MVCInyectProps(".concat((0, _utils.getDisplayName)(Component), ")");

    var Connect = _react["default"].memo(ConnectComponent);

    if (forwardRef) {
      Connect = _react["default"].forwardRef(function (props, ref) {
        return (
          /*#__PURE__*/
          _react["default"].createElement(ConnectComponent, (0, _extends2["default"])({}, props, {
            reduxMVCForwardedRef: ref
          }))
        );
      });
    }

    Connect.displayName = "MVCConnect(".concat((0, _utils.getDisplayName)(Component), ")");
    return (0, _hoistNonReactStatics["default"])(Connect, Component);
  };
};

exports.connect = connect;